---
title: Function.length
slug: Web/JavaScript/Reference/Global_Objects/Function/length
tags:
  - Function
  - JavaScript
  - Property
---
<div>{{JSRef}}</div>

<p>The <strong><code>length</code></strong> property indicates the number of parameters expected by the function.</p>

<div>{{EmbedInteractiveExample("pages/js/function-length.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div>{{js_property_attributes(0,0,1)}}</div>

<h2 id="Description">Description</h2>

<p><code>length</code> is a property of a function object, and indicates how many arguments the function expects, i.e. the number of formal parameters. This number excludes the {{jsxref("rest_parameters", "rest parameter", "", 1)}} and only includes parameters before the first one with a default value. By contrast, {{jsxref("Functions_and_function_scope/arguments/length", "arguments.length")}} is local to a function and provides the number of arguments actually passed to the function.</p>

<h3 id="Data_property_of_the_Function_constructor">Data property of the Function constructor</h3>

<p>The {{jsxref("Function")}} constructor is itself a {{jsxref("Function")}} object. Its <code>length</code> data property has a value of 1. The property attributes are: Writable: <code>false</code>, Enumerable: <code>false</code>, Configurable: <code>true</code>.</p>

<h3 id="Property_of_the_Function_prototype_object">Property of the Function prototype object</h3>

<p>The length property of the {{jsxref("Function")}} prototype object has a value of 0.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_function_length">Using function length</h3>

<pre class="brush: js notranslate">console.log(Function.length); /* 1 */

console.log((function()        {}).length); /* 0 */
console.log((function(a)       {}).length); /* 1 */
console.log((function(a, b)    {}).length); /* 2 etc. */

console.log((function(...args) {}).length);
// 0, rest parameter is not counted

console.log((function(a, b = 1, c) {}).length);
// 1, only parameters before the first one with
// a default value is counted</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-function-instances-length', 'Function.length')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Function.length")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Function")}}</li>
</ul>
